#version 330 core
#extension GL_ARB_explicit_attrib_location: enable

in vec2 uv;
in vec4 color;
in vec4 rgbaFog;
in float fogAmount;
in float glowLevel;

layout(location = 0) out vec4 outColor;
layout(location = 1) out vec4 outGlow;

uniform sampler2D entityTex;
uniform float alphaTest = 0.001;

flat in int renderFlags;
flat in vec3 normal;

#include fogandlight.fsh

void main () {
	vec4 texColor = texture(entityTex, uv) * color;
	
	if (((renderFlags >> 14) & 1) > 0) {
		outColor = applyFogAndShadowWithNormal(texColor, fogAmount, normal, 1, 0.35);
	} else {
		outColor = applyFogAndShadow(texColor, fogAmount);
	}

	/*outColor.r = normal.x;
	outColor.g = normal.y;
	outColor.b = normal.z;*/
	

	if (outColor.a < alphaTest) discard;
	
	outGlow = vec4(glowLevel, 0, 0, color.a);
}