#version 330 core
#extension GL_ARB_explicit_attrib_location: enable

in vec4 color;
in vec2 uv;
in vec4 rgbaFog;
in float fogAmount;
in float glowLevel;
flat in int renderFlags;
in vec3 normal;

layout(location = 0) out vec4 outColor;
layout(location = 1) out vec4 outGlow;

uniform sampler2D tex;
uniform float alphaTest = 0.1;

#include fogandlight.fsh

void main () {
  outColor = applyFogAndShadow(texture(tex, uv) * color, fogAmount);
  if (outColor.a < alphaTest) discard;

  if ((renderFlags & (1 << 14)) > 0) {
      float b = getBrightnessFromNormal(normal, 1, 0.45);
      outColor *= vec4(b, b, b, 1);
  }
  
//  outColor = vec4(normal.x, normal.y, normal.z, 1);

  outGlow = vec4(glowLevel, 0, 0, outColor.a);
}