#version 330 core

uniform sampler2D accumulation;
uniform sampler2D revealage;
uniform sampler2D inGlow;

in vec2 v_texcoord;

layout(location = 0) out vec4 outColor;
layout(location = 1) out vec4 outGlow;

void main(void)
{
	float reveal = max(0, texture(revealage, v_texcoord).r);
	
	if (reveal >= 1.0) {
		discard;
	}
	
	vec4 accum = texture(accumulation, v_texcoord);
	
	vec3 avgColor = accum.rgb / max(accum.a,  0.00001);
	
	outColor = vec4(avgColor, 1 - reveal);
	
	outGlow = texture(inGlow, v_texcoord);
}